<html>
<head>
<title>OgreImageResampler.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_421e028b72e6118d2afd1c1cfce2a3b8.html">src</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreImageResampler.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreImageResampler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef OGREIMAGERESAMPLER_H</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define OGREIMAGERESAMPLER_H</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// this file is inlined into OgreImage.cpp!</span>
<a name="l00034"></a>00034 <span class="comment">// do not include anywhere else.</span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a>00043 <span class="comment">// variable name hints:</span>
<a name="l00044"></a>00044 <span class="comment">// sx_48 = 16/48-bit fixed-point x-position in source</span>
<a name="l00045"></a>00045 <span class="comment">// stepx = difference between adjacent sx_48 values</span>
<a name="l00046"></a>00046 <span class="comment">// sx1 = lower-bound integer x-position in source</span>
<a name="l00047"></a>00047 <span class="comment">// sx2 = upper-bound integer x-position in source</span>
<a name="l00048"></a>00048 <span class="comment">// sxf = fractional weight between sx1 and sx2</span>
<a name="l00049"></a>00049 <span class="comment">// x,y,z = location of output pixel in destination</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// nearest-neighbor resampler, does not convert formats.</span>
<a name="l00052"></a>00052 <span class="comment">// templated on bytes-per-pixel to allow compiler optimizations, such</span>
<a name="l00053"></a>00053 <span class="comment">// as simplifying memcpy() and replacing multiplies with bitshifts</span>
<a name="l00054"></a><a class="code" href="structOgre_1_1NearestResampler.html">00054</a> <span class="keyword">template</span>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemsize&gt; <span class="keyword">struct </span><a class="code" href="structOgre_1_1NearestResampler.html">NearestResampler</a> {
<a name="l00055"></a><a class="code" href="structOgre_1_1NearestResampler.html#a13aed755b21d090e3896bba5e60630d0">00055</a>     <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="structOgre_1_1NearestResampler.html#a13aed755b21d090e3896bba5e60630d0">scale</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; dst) {
<a name="l00056"></a>00056         <span class="comment">// assert(src.format == dst.format);</span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="comment">// srcdata stays at beginning, pdst is a moving pointer</span>
<a name="l00059"></a>00059         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* srcdata = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)src.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00060"></a>00060         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* pdst = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)dst.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062         <span class="comment">// sx_48,sy_48,sz_48 represent current position in source</span>
<a name="l00063"></a>00063         <span class="comment">// using 16/48-bit fixed precision, incremented by steps</span>
<a name="l00064"></a>00064         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepx = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>();
<a name="l00065"></a>00065         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepy = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>();
<a name="l00066"></a>00066         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepz = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068         <span class="comment">// note: ((stepz&gt;&gt;1) - 1) is an extra half-step increment to adjust</span>
<a name="l00069"></a>00069         <span class="comment">// for the center of the destination pixel, not the top-left corner</span>
<a name="l00070"></a>00070         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sz_48 = (stepz &gt;&gt; 1) - 1;
<a name="l00071"></a>00071         <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> z = dst.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a>; z &lt; dst.<a class="code" href="structOgre_1_1Box.html#a26cb2e011c3dec1ff625716e1778233a">back</a>; z++, sz_48 += stepz) {
<a name="l00072"></a>00072             <span class="keywordtype">size_t</span> srczoff = (size_t)(sz_48 &gt;&gt; 48) * src.<a class="code" href="classOgre_1_1PixelBox.html#a5f4ac4f2e735678fc8b3ddc1068674dd" title="Number of elements between the top left pixel of one (depth) slice and the top left pixel of the next...">slicePitch</a>;
<a name="l00073"></a>00073             
<a name="l00074"></a>00074             <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sy_48 = (stepy &gt;&gt; 1) - 1;
<a name="l00075"></a>00075             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> y = dst.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>; y &lt; dst.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>; y++, sy_48 += stepy) {
<a name="l00076"></a>00076                 <span class="keywordtype">size_t</span> srcyoff = (size_t)(sy_48 &gt;&gt; 48) * src.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a>;
<a name="l00077"></a>00077             
<a name="l00078"></a>00078                 <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sx_48 = (stepx &gt;&gt; 1) - 1;
<a name="l00079"></a>00079                 <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> x = dst.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>; x &lt; dst.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a>; x++, sx_48 += stepx) {
<a name="l00080"></a>00080                     <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* psrc = srcdata +
<a name="l00081"></a>00081                         elemsize*((size_t)(sx_48 &gt;&gt; 48) + srcyoff + srczoff);
<a name="l00082"></a>00082                     memcpy(pdst, psrc, elemsize);
<a name="l00083"></a>00083                     pdst += elemsize;
<a name="l00084"></a>00084                 }
<a name="l00085"></a>00085                 pdst += elemsize*dst.<a class="code" href="classOgre_1_1PixelBox.html#a6c57caf05a1a9c91780f6602bec71402" title="Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of ...">getRowSkip</a>();
<a name="l00086"></a>00086             }
<a name="l00087"></a>00087             pdst += elemsize*dst.<a class="code" href="classOgre_1_1PixelBox.html#a27f6e0e9f80a2a3397ef5550875cee97" title="Get the number of elements between one past the right bottom pixel of one slice and the left top pixe...">getSliceSkip</a>();
<a name="l00088"></a>00088         }
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090 };
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="comment">// default floating-point linear resampler, does format conversion</span>
<a name="l00094"></a><a class="code" href="structOgre_1_1LinearResampler.html">00094</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1LinearResampler.html">LinearResampler</a> {
<a name="l00095"></a><a class="code" href="structOgre_1_1LinearResampler.html#a7a82c967cb98c1db45715509f72fc43b">00095</a>     <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="structOgre_1_1LinearResampler.html#a7a82c967cb98c1db45715509f72fc43b">scale</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; dst) {
<a name="l00096"></a>00096         <span class="keywordtype">size_t</span> srcelemsize = <a class="code" href="classOgre_1_1PixelUtil.html#a1e39ec27d40f044a058e6fef850a1fbe" title="Returns the size in bytes of an element of the given pixel format.">PixelUtil::getNumElemBytes</a>(src.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>);
<a name="l00097"></a>00097         <span class="keywordtype">size_t</span> dstelemsize = <a class="code" href="classOgre_1_1PixelUtil.html#a1e39ec27d40f044a058e6fef850a1fbe" title="Returns the size in bytes of an element of the given pixel format.">PixelUtil::getNumElemBytes</a>(dst.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         <span class="comment">// srcdata stays at beginning, pdst is a moving pointer</span>
<a name="l00100"></a>00100         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* srcdata = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)src.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00101"></a>00101         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* pdst = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)dst.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00102"></a>00102         
<a name="l00103"></a>00103         <span class="comment">// sx_48,sy_48,sz_48 represent current position in source</span>
<a name="l00104"></a>00104         <span class="comment">// using 16/48-bit fixed precision, incremented by steps</span>
<a name="l00105"></a>00105         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepx = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>();
<a name="l00106"></a>00106         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepy = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>();
<a name="l00107"></a>00107         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepz = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>();
<a name="l00108"></a>00108         
<a name="l00109"></a>00109         <span class="comment">// temp is 16/16 bit fixed precision, used to adjust a source</span>
<a name="l00110"></a>00110         <span class="comment">// coordinate (x, y, or z) backwards by half a pixel so that the</span>
<a name="l00111"></a>00111         <span class="comment">// integer bits represent the first sample (eg, sx1) and the</span>
<a name="l00112"></a>00112         <span class="comment">// fractional bits are the blend weight of the second sample</span>
<a name="l00113"></a>00113         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <span class="comment">// note: ((stepz&gt;&gt;1) - 1) is an extra half-step increment to adjust</span>
<a name="l00116"></a>00116         <span class="comment">// for the center of the destination pixel, not the top-left corner</span>
<a name="l00117"></a>00117         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sz_48 = (stepz &gt;&gt; 1) - 1;
<a name="l00118"></a>00118         <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> z = dst.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a>; z &lt; dst.<a class="code" href="structOgre_1_1Box.html#a26cb2e011c3dec1ff625716e1778233a">back</a>; z++, sz_48+=stepz) {
<a name="l00119"></a>00119             temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sz_48 &gt;&gt; 32);
<a name="l00120"></a>00120             temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00121"></a>00121             <span class="keywordtype">size_t</span> sz1 = temp &gt;&gt; 16;                 <span class="comment">// src z, sample #1</span>
<a name="l00122"></a>00122             <span class="keywordtype">size_t</span> sz2 = std::min(sz1+1,src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>()-1);<span class="comment">// src z, sample #2</span>
<a name="l00123"></a>00123             <span class="keywordtype">float</span> szf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of sample #2</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125             <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sy_48 = (stepy &gt;&gt; 1) - 1;
<a name="l00126"></a>00126             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> y = dst.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>; y &lt; dst.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>; y++, sy_48+=stepy) {
<a name="l00127"></a>00127                 temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sy_48 &gt;&gt; 32);
<a name="l00128"></a>00128                 temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00129"></a>00129                 <span class="keywordtype">size_t</span> sy1 = temp &gt;&gt; 16;                    <span class="comment">// src y #1</span>
<a name="l00130"></a>00130                 <span class="keywordtype">size_t</span> sy2 = std::min(sy1+1,src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>()-1);<span class="comment">// src y #2</span>
<a name="l00131"></a>00131                 <span class="keywordtype">float</span> syf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of #2</span>
<a name="l00132"></a>00132                 
<a name="l00133"></a>00133                 <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sx_48 = (stepx &gt;&gt; 1) - 1;
<a name="l00134"></a>00134                 <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> x = dst.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>; x &lt; dst.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a>; x++, sx_48+=stepx) {
<a name="l00135"></a>00135                     temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sx_48 &gt;&gt; 32);
<a name="l00136"></a>00136                     temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00137"></a>00137                     <span class="keywordtype">size_t</span> sx1 = temp &gt;&gt; 16;                    <span class="comment">// src x #1</span>
<a name="l00138"></a>00138                     <span class="keywordtype">size_t</span> sx2 = std::min(sx1+1,src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>()-1);<span class="comment">// src x #2</span>
<a name="l00139"></a>00139                     <span class="keywordtype">float</span> sxf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of #2</span>
<a name="l00140"></a>00140                 
<a name="l00141"></a>00141                     <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> x1y1z1, x2y1z1, x1y2z1, x2y2z1;
<a name="l00142"></a>00142                     <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> x1y1z2, x2y1z2, x1y2z2, x2y2z2;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#define UNPACK(dst,x,y,z) PixelUtil::unpackColour(&amp;dst, src.format, \</span>
<a name="l00145"></a>00145 <span class="preprocessor">    srcdata + srcelemsize*((x)+(y)*src.rowPitch+(z)*src.slicePitch))</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147                     <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x1y1z1,sx1,sy1,sz1); <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x2y1z1,sx2,sy1,sz1);
<a name="l00148"></a>00148                     <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x1y2z1,sx1,sy2,sz1); <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x2y2z1,sx2,sy2,sz1);
<a name="l00149"></a>00149                     <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x1y1z2,sx1,sy1,sz2); <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x2y1z2,sx2,sy1,sz2);
<a name="l00150"></a>00150                     <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x1y2z2,sx1,sy2,sz2); <a class="code" href="OgreImageResampler_8h.html#aeb34b7ef2dbf4c91dd7c37f88e852c03">UNPACK</a>(x2y2z2,sx2,sy2,sz2);
<a name="l00151"></a>00151 <span class="preprocessor">#undef UNPACK</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153                     <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> accum =
<a name="l00154"></a>00154                         x1y1z1 * ((1.0f - sxf)*(1.0f - syf)*(1.0f - szf)) +
<a name="l00155"></a>00155                         x2y1z1 * (        sxf *(1.0f - syf)*(1.0f - szf)) +
<a name="l00156"></a>00156                         x1y2z1 * ((1.0f - sxf)*        syf *(1.0f - szf)) +
<a name="l00157"></a>00157                         x2y2z1 * (        sxf *        syf *(1.0f - szf)) +
<a name="l00158"></a>00158                         x1y1z2 * ((1.0f - sxf)*(1.0f - syf)*        szf ) +
<a name="l00159"></a>00159                         x2y1z2 * (        sxf *(1.0f - syf)*        szf ) +
<a name="l00160"></a>00160                         x1y2z2 * ((1.0f - sxf)*        syf *        szf ) +
<a name="l00161"></a>00161                         x2y2z2 * (        sxf *        syf *        szf );
<a name="l00162"></a>00162 
<a name="l00163"></a>00163                     <a class="code" href="classOgre_1_1PixelUtil.html#a793a7ae2bb8edec89ab520958ac33f40" title="Pack a colour value to memory.">PixelUtil::packColour</a>(accum, dst.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>, pdst);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165                     pdst += dstelemsize;
<a name="l00166"></a>00166                 }
<a name="l00167"></a>00167                 pdst += dstelemsize*dst.<a class="code" href="classOgre_1_1PixelBox.html#a6c57caf05a1a9c91780f6602bec71402" title="Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of ...">getRowSkip</a>();
<a name="l00168"></a>00168             }
<a name="l00169"></a>00169             pdst += dstelemsize*dst.<a class="code" href="classOgre_1_1PixelBox.html#a27f6e0e9f80a2a3397ef5550875cee97" title="Get the number of elements between one past the right bottom pixel of one slice and the left top pixe...">getSliceSkip</a>();
<a name="l00170"></a>00170         }
<a name="l00171"></a>00171     }
<a name="l00172"></a>00172 };
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="comment">// float32 linear resampler, converts FLOAT32_RGB/FLOAT32_RGBA only.</span>
<a name="l00176"></a>00176 <span class="comment">// avoids overhead of pixel unpack/repack function calls</span>
<a name="l00177"></a><a class="code" href="structOgre_1_1LinearResampler__Float32.html">00177</a> <span class="keyword">struct </span><a class="code" href="structOgre_1_1LinearResampler__Float32.html">LinearResampler_Float32</a> {
<a name="l00178"></a><a class="code" href="structOgre_1_1LinearResampler__Float32.html#a86e44dcdddb74c9ea459b6b1c57a0b21">00178</a>     <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="structOgre_1_1LinearResampler__Float32.html#a86e44dcdddb74c9ea459b6b1c57a0b21">scale</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; dst) {
<a name="l00179"></a>00179         <span class="keywordtype">size_t</span> srcchannels = <a class="code" href="classOgre_1_1PixelUtil.html#a1e39ec27d40f044a058e6fef850a1fbe" title="Returns the size in bytes of an element of the given pixel format.">PixelUtil::getNumElemBytes</a>(src.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>) / <span class="keyword">sizeof</span>(float);
<a name="l00180"></a>00180         <span class="keywordtype">size_t</span> dstchannels = <a class="code" href="classOgre_1_1PixelUtil.html#a1e39ec27d40f044a058e6fef850a1fbe" title="Returns the size in bytes of an element of the given pixel format.">PixelUtil::getNumElemBytes</a>(dst.<a class="code" href="classOgre_1_1PixelBox.html#aa4101fdc288dc41dddac88440b4d0818" title="The pixel format.">format</a>) / <span class="keyword">sizeof</span>(float);
<a name="l00181"></a>00181         <span class="comment">// assert(srcchannels == 3 || srcchannels == 4);</span>
<a name="l00182"></a>00182         <span class="comment">// assert(dstchannels == 3 || dstchannels == 4);</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         <span class="comment">// srcdata stays at beginning, pdst is a moving pointer</span>
<a name="l00185"></a>00185         <span class="keywordtype">float</span>* srcdata = (<span class="keywordtype">float</span>*)src.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00186"></a>00186         <span class="keywordtype">float</span>* pdst = (<span class="keywordtype">float</span>*)dst.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00187"></a>00187         
<a name="l00188"></a>00188         <span class="comment">// sx_48,sy_48,sz_48 represent current position in source</span>
<a name="l00189"></a>00189         <span class="comment">// using 16/48-bit fixed precision, incremented by steps</span>
<a name="l00190"></a>00190         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepx = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>();
<a name="l00191"></a>00191         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepy = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>();
<a name="l00192"></a>00192         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepz = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>();
<a name="l00193"></a>00193         
<a name="l00194"></a>00194         <span class="comment">// temp is 16/16 bit fixed precision, used to adjust a source</span>
<a name="l00195"></a>00195         <span class="comment">// coordinate (x, y, or z) backwards by half a pixel so that the</span>
<a name="l00196"></a>00196         <span class="comment">// integer bits represent the first sample (eg, sx1) and the</span>
<a name="l00197"></a>00197         <span class="comment">// fractional bits are the blend weight of the second sample</span>
<a name="l00198"></a>00198         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200         <span class="comment">// note: ((stepz&gt;&gt;1) - 1) is an extra half-step increment to adjust</span>
<a name="l00201"></a>00201         <span class="comment">// for the center of the destination pixel, not the top-left corner</span>
<a name="l00202"></a>00202         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sz_48 = (stepz &gt;&gt; 1) - 1;
<a name="l00203"></a>00203         <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> z = dst.<a class="code" href="structOgre_1_1Box.html#a6057f53bf949ee0725aeb52d1e480f4c">front</a>; z &lt; dst.<a class="code" href="structOgre_1_1Box.html#a26cb2e011c3dec1ff625716e1778233a">back</a>; z++, sz_48+=stepz) {
<a name="l00204"></a>00204             temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sz_48 &gt;&gt; 32);
<a name="l00205"></a>00205             temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00206"></a>00206             <span class="keywordtype">size_t</span> sz1 = temp &gt;&gt; 16;                 <span class="comment">// src z, sample #1</span>
<a name="l00207"></a>00207             <span class="keywordtype">size_t</span> sz2 = std::min(sz1+1,src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>()-1);<span class="comment">// src z, sample #2</span>
<a name="l00208"></a>00208             <span class="keywordtype">float</span> szf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of sample #2</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210             <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sy_48 = (stepy &gt;&gt; 1) - 1;
<a name="l00211"></a>00211             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> y = dst.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>; y &lt; dst.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>; y++, sy_48+=stepy) {
<a name="l00212"></a>00212                 temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sy_48 &gt;&gt; 32);
<a name="l00213"></a>00213                 temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00214"></a>00214                 <span class="keywordtype">size_t</span> sy1 = temp &gt;&gt; 16;                    <span class="comment">// src y #1</span>
<a name="l00215"></a>00215                 <span class="keywordtype">size_t</span> sy2 = std::min(sy1+1,src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>()-1);<span class="comment">// src y #2</span>
<a name="l00216"></a>00216                 <span class="keywordtype">float</span> syf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of #2</span>
<a name="l00217"></a>00217                 
<a name="l00218"></a>00218                 <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sx_48 = (stepx &gt;&gt; 1) - 1;
<a name="l00219"></a>00219                 <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> x = dst.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>; x &lt; dst.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a>; x++, sx_48+=stepx) {
<a name="l00220"></a>00220                     temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sx_48 &gt;&gt; 32);
<a name="l00221"></a>00221                     temp = (temp &gt; 0x8000)? temp - 0x8000 : 0;
<a name="l00222"></a>00222                     <span class="keywordtype">size_t</span> sx1 = temp &gt;&gt; 16;                    <span class="comment">// src x #1</span>
<a name="l00223"></a>00223                     <span class="keywordtype">size_t</span> sx2 = std::min(sx1+1,src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>()-1);<span class="comment">// src x #2</span>
<a name="l00224"></a>00224                     <span class="keywordtype">float</span> sxf = (temp &amp; 0xFFFF) / 65536.f; <span class="comment">// weight of #2</span>
<a name="l00225"></a>00225                     
<a name="l00226"></a>00226                     <span class="comment">// process R,G,B,A simultaneously for cache coherence?</span>
<a name="l00227"></a>00227                     <span class="keywordtype">float</span> accum[4] = { 0.0f, 0.0f, 0.0f, 0.0f };
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="preprocessor">#define ACCUM3(x,y,z,factor) \</span>
<a name="l00230"></a>00230 <span class="preprocessor">    { float f = factor; \</span>
<a name="l00231"></a>00231 <span class="preprocessor">    size_t off = (x+y*src.rowPitch+z*src.slicePitch)*srcchannels; \</span>
<a name="l00232"></a>00232 <span class="preprocessor">    accum[0]+=srcdata[off+0]*f; accum[1]+=srcdata[off+1]*f; \</span>
<a name="l00233"></a>00233 <span class="preprocessor">    accum[2]+=srcdata[off+2]*f; }</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>
<a name="l00235"></a>00235 <span class="preprocessor">#define ACCUM4(x,y,z,factor) \</span>
<a name="l00236"></a>00236 <span class="preprocessor">    { float f = factor; \</span>
<a name="l00237"></a>00237 <span class="preprocessor">    size_t off = (x+y*src.rowPitch+z*src.slicePitch)*srcchannels; \</span>
<a name="l00238"></a>00238 <span class="preprocessor">    accum[0]+=srcdata[off+0]*f; accum[1]+=srcdata[off+1]*f; \</span>
<a name="l00239"></a>00239 <span class="preprocessor">    accum[2]+=srcdata[off+2]*f; accum[3]+=srcdata[off+3]*f; }</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>
<a name="l00241"></a>00241                     <span class="keywordflow">if</span> (srcchannels == 3 || dstchannels == 3) {
<a name="l00242"></a>00242                         <span class="comment">// RGB, no alpha</span>
<a name="l00243"></a>00243                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx1,sy1,sz1,(1.0f-sxf)*(1.0f-syf)*(1.0f-szf));
<a name="l00244"></a>00244                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx2,sy1,sz1,      sxf *(1.0f-syf)*(1.0f-szf));
<a name="l00245"></a>00245                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx1,sy2,sz1,(1.0f-sxf)*      syf *(1.0f-szf));
<a name="l00246"></a>00246                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx2,sy2,sz1,      sxf *      syf *(1.0f-szf));
<a name="l00247"></a>00247                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx1,sy1,sz2,(1.0f-sxf)*(1.0f-syf)*      szf );
<a name="l00248"></a>00248                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx2,sy1,sz2,      sxf *(1.0f-syf)*      szf );
<a name="l00249"></a>00249                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx1,sy2,sz2,(1.0f-sxf)*      syf *      szf );
<a name="l00250"></a>00250                         <a class="code" href="OgreImageResampler_8h.html#abfa4aeaeb25cca0360ae0ba0aef7cf9e">ACCUM3</a>(sx2,sy2,sz2,      sxf *      syf *      szf );
<a name="l00251"></a>00251                         accum[3] = 1.0f;
<a name="l00252"></a>00252                     } <span class="keywordflow">else</span> {
<a name="l00253"></a>00253                         <span class="comment">// RGBA</span>
<a name="l00254"></a>00254                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx1,sy1,sz1,(1.0f-sxf)*(1.0f-syf)*(1.0f-szf));
<a name="l00255"></a>00255                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx2,sy1,sz1,      sxf *(1.0f-syf)*(1.0f-szf));
<a name="l00256"></a>00256                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx1,sy2,sz1,(1.0f-sxf)*      syf *(1.0f-szf));
<a name="l00257"></a>00257                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx2,sy2,sz1,      sxf *      syf *(1.0f-szf));
<a name="l00258"></a>00258                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx1,sy1,sz2,(1.0f-sxf)*(1.0f-syf)*      szf );
<a name="l00259"></a>00259                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx2,sy1,sz2,      sxf *(1.0f-syf)*      szf );
<a name="l00260"></a>00260                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx1,sy2,sz2,(1.0f-sxf)*      syf *      szf );
<a name="l00261"></a>00261                         <a class="code" href="OgreImageResampler_8h.html#a8d51fc9045f78003752d2f5c88b34914">ACCUM4</a>(sx2,sy2,sz2,      sxf *      syf *      szf );
<a name="l00262"></a>00262                     }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264                     memcpy(pdst, accum, <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>)*dstchannels);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 <span class="preprocessor">#undef ACCUM3</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span><span class="preprocessor">#undef ACCUM4</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span>
<a name="l00269"></a>00269                     pdst += dstchannels;
<a name="l00270"></a>00270                 }
<a name="l00271"></a>00271                 pdst += dstchannels*dst.<a class="code" href="classOgre_1_1PixelBox.html#a6c57caf05a1a9c91780f6602bec71402" title="Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of ...">getRowSkip</a>();
<a name="l00272"></a>00272             }
<a name="l00273"></a>00273             pdst += dstchannels*dst.<a class="code" href="classOgre_1_1PixelBox.html#a27f6e0e9f80a2a3397ef5550875cee97" title="Get the number of elements between one past the right bottom pixel of one slice and the left top pixe...">getSliceSkip</a>();
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276 };
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">// byte linear resampler, does not do any format conversions.</span>
<a name="l00281"></a>00281 <span class="comment">// only handles pixel formats that use 1 byte per color channel.</span>
<a name="l00282"></a>00282 <span class="comment">// 2D only; punts 3D pixelboxes to default LinearResampler (slow).</span>
<a name="l00283"></a>00283 <span class="comment">// templated on bytes-per-pixel to allow compiler optimizations, such</span>
<a name="l00284"></a>00284 <span class="comment">// as unrolling loops and replacing multiplies with bitshifts</span>
<a name="l00285"></a><a class="code" href="structOgre_1_1LinearResampler__Byte.html">00285</a> <span class="keyword">template</span>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> channels&gt; <span class="keyword">struct </span><a class="code" href="structOgre_1_1LinearResampler__Byte.html">LinearResampler_Byte</a> {
<a name="l00286"></a><a class="code" href="structOgre_1_1LinearResampler__Byte.html#a1404776f44fbb79b14ec774ec7ac25af">00286</a>     <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="structOgre_1_1LinearResampler__Byte.html#a1404776f44fbb79b14ec774ec7ac25af">scale</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; src, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>&amp; dst) {
<a name="l00287"></a>00287         <span class="comment">// assert(src.format == dst.format);</span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289         <span class="comment">// only optimized for 2D</span>
<a name="l00290"></a>00290         <span class="keywordflow">if</span> (src.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>() &gt; 1 || dst.<a class="code" href="structOgre_1_1Box.html#a35a70afaf89bbd6371a9abdc9e1da469" title="Get the depth of this box.">getDepth</a>() &gt; 1) {
<a name="l00291"></a>00291             <a class="code" href="structOgre_1_1LinearResampler__Byte.html#a1404776f44fbb79b14ec774ec7ac25af">LinearResampler::scale</a>(src, dst);
<a name="l00292"></a>00292             <span class="keywordflow">return</span>;
<a name="l00293"></a>00293         }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295         <span class="comment">// srcdata stays at beginning of slice, pdst is a moving pointer</span>
<a name="l00296"></a>00296         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* srcdata = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)src.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00297"></a>00297         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* pdst = (<a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>*)dst.<a class="code" href="classOgre_1_1PixelBox.html#ac4fe215e13fc38d6a45e0c40ee2f1425" title="The data pointer.">data</a>;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299         <span class="comment">// sx_48,sy_48 represent current position in source</span>
<a name="l00300"></a>00300         <span class="comment">// using 16/48-bit fixed precision, incremented by steps</span>
<a name="l00301"></a>00301         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepx = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a7621962346ee18c3df6a405d115548a8" title="Get the width of this box.">getWidth</a>();
<a name="l00302"></a>00302         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> stepy = ((<a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>)src.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>() &lt;&lt; 48) / dst.<a class="code" href="structOgre_1_1Box.html#a93d5935ee18c29336ea11460a9d30b53" title="Get the height of this box.">getHeight</a>();
<a name="l00303"></a>00303         
<a name="l00304"></a>00304         <span class="comment">// bottom 28 bits of temp are 16/12 bit fixed precision, used to</span>
<a name="l00305"></a>00305         <span class="comment">// adjust a source coordinate backwards by half a pixel so that the</span>
<a name="l00306"></a>00306         <span class="comment">// integer bits represent the first sample (eg, sx1) and the</span>
<a name="l00307"></a>00307         <span class="comment">// fractional bits are the blend weight of the second sample</span>
<a name="l00308"></a>00308         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp;
<a name="l00309"></a>00309         
<a name="l00310"></a>00310         <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sy_48 = (stepy &gt;&gt; 1) - 1;
<a name="l00311"></a>00311         <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> y = dst.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>; y &lt; dst.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>; y++, sy_48+=stepy) {
<a name="l00312"></a>00312             temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sy_48 &gt;&gt; 36);
<a name="l00313"></a>00313             temp = (temp &gt; 0x800)? temp - 0x800: 0;
<a name="l00314"></a>00314             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> syf = temp &amp; 0xFFF;
<a name="l00315"></a>00315             <span class="keywordtype">size_t</span> sy1 = temp &gt;&gt; 12;
<a name="l00316"></a>00316             <span class="keywordtype">size_t</span> sy2 = std::min(sy1+1, src.<a class="code" href="structOgre_1_1Box.html#a66b5764c9ac1aad8410e9883c74b522a">bottom</a>-src.<a class="code" href="structOgre_1_1Box.html#aebfb3bd646373c45c9e38735640f6e3a">top</a>-1);
<a name="l00317"></a>00317             <span class="keywordtype">size_t</span> syoff1 = sy1 * src.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a>;
<a name="l00318"></a>00318             <span class="keywordtype">size_t</span> syoff2 = sy2 * src.<a class="code" href="classOgre_1_1PixelBox.html#aacf8f1ebed40c557389d9d1e9dda3b68" title="Number of elements between the leftmost pixel of one row and the left pixel of the next...">rowPitch</a>;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320             <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a> sx_48 = (stepx &gt;&gt; 1) - 1;
<a name="l00321"></a>00321             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> x = dst.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>; x &lt; dst.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a>; x++, sx_48+=stepx) {
<a name="l00322"></a>00322                 temp = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(sx_48 &gt;&gt; 36);
<a name="l00323"></a>00323                 temp = (temp &gt; 0x800)? temp - 0x800 : 0;
<a name="l00324"></a>00324                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sxf = temp &amp; 0xFFF;
<a name="l00325"></a>00325                 <span class="keywordtype">size_t</span> sx1 = temp &gt;&gt; 12;
<a name="l00326"></a>00326                 <span class="keywordtype">size_t</span> sx2 = std::min(sx1+1, src.<a class="code" href="structOgre_1_1Box.html#a57531708bc749511715f37648d105aad">right</a>-src.<a class="code" href="structOgre_1_1Box.html#a8c667f45bbbe5be0577025436a7e50a0">left</a>-1);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sxfsyf = sxf*syf;
<a name="l00329"></a>00329                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0; k &lt; channels; k++) {
<a name="l00330"></a>00330                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> accum =
<a name="l00331"></a>00331                         srcdata[(sx1 + syoff1)*channels+k]*(0x1000000-(sxf&lt;&lt;12)-(syf&lt;&lt;12)+sxfsyf) +
<a name="l00332"></a>00332                         srcdata[(sx2 + syoff1)*channels+k]*((sxf&lt;&lt;12)-sxfsyf) +
<a name="l00333"></a>00333                         srcdata[(sx1 + syoff2)*channels+k]*((syf&lt;&lt;12)-sxfsyf) +
<a name="l00334"></a>00334                         srcdata[(sx2 + syoff2)*channels+k]*sxfsyf;
<a name="l00335"></a>00335                     <span class="comment">// accum is computed using 8/24-bit fixed-point math</span>
<a name="l00336"></a>00336                     <span class="comment">// (maximum is 0xFF000000; rounding will not cause overflow)</span>
<a name="l00337"></a>00337                     *pdst++ = <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a><span class="keyword">&gt;</span>((accum + 0x800000) &gt;&gt; 24);
<a name="l00338"></a>00338                 }
<a name="l00339"></a>00339             }
<a name="l00340"></a>00340             pdst += channels*dst.<a class="code" href="classOgre_1_1PixelBox.html#a6c57caf05a1a9c91780f6602bec71402" title="Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of ...">getRowSkip</a>();
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343 };
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
